"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getRequestHandlerForRoutes;

var _url = require("url");

var _resolve = _interopRequireDefault(require("./resolve"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getRequestHandlerForRoutes(routes, app, customHandler) {
  var nextHandler = app.getRequestHandler();
  return function (req, res) {
    var params = (0, _resolve.default)(routes, req.url);

    if (!params) {
      nextHandler(req, res, (0, _url.parse)(req.url));
      return;
    }

    var page = params.page,
        query = params.query;

    if (page) {
      if (customHandler) {
        customHandler({
          req: req,
          res: res,
          page: page,
          query: query
        });
      } else {
        app.render(req, res, page, query);
      }
    } else {
      nextHandler(req, res, (0, _url.parse)(req.url));
    }
  };
}