"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = resolve;

var _url = require("url");

var _matchRoute = _interopRequireDefault(require("./matchRoute"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Given a URL, will return the Next page and query that matches
 */
function resolve(routes, requestUrl) {
  var _parse = (0, _url.parse)(requestUrl, true),
      requestPath = _parse.pathname,
      query = _parse.query;

  if (routes.length === 0) {
    return null;
  }

  var matches = routes.reduce(function (acc, route) {
    var params = (0, _matchRoute.default)(route, requestPath);

    if (params) {
      acc.push({
        route: route,
        params: params
      });
      return acc;
    }

    return acc;
  }, []);

  if (matches.length === 0) {
    return null;
  }

  var _matches$ = matches[0],
      route = _matches$.route,
      params = _matches$.params;
  return {
    page: route.page,
    query: _objectSpread({}, params, query)
  };
}